/*
 * REEEEALLY hacky test to show that the LFH is good for some things ;)
 *
 */
#include "stdafx.h"
#include <windows.h>
#include <stdlib.h>


int main(int argc, char* argv[])
{
	int nSteps = 1000000;
	if (argc > 1) {
		nSteps = atoi(argv[1]);
	}
	printf("Start - %d length run\n", nSteps );
	int nBlocks = 100000;
	int maxBlockSize = 1000000;
	int nFreq = 10;
	int nsFreq = 3;
	int i;

	LARGE_INTEGER start, end, freq;
	QueryPerformanceFrequency(&freq);

	HANDLE h = GetProcessHeap();

	void ** ppblocks = new void* [nBlocks];
	srand(0);

	QueryPerformanceCounter(&start);
	for (i=0;i<nBlocks;i++) {
		int size = 1+rand();
		ppblocks[i] = HeapAlloc(h,0,size);
	}

	for (i=0;i<nSteps;i++) {
		int block = rand() % nBlocks;
		HeapFree(h,0,ppblocks[block]);
		int size = 1+rand();
		if (i % nFreq == 0) size *= size;
		if (i % nsFreq == 0) size = size % 100;
		size %= maxBlockSize;
		ppblocks[block] = HeapAlloc(h,0,size);
	}
	QueryPerformanceCounter(&end);
	double d = ((double)end.QuadPart - (double)start.QuadPart)/(double)freq.QuadPart;
	printf("%f\n", d);
	
	return 0;
}

